use domo_proto::packet::Packet;

use crate::filter::{Filter, FilterState};

use super::function_filter::FunctionFilter;

impl Filter<Packet> for FunctionFilter {
    fn filter(&self, f: FilterState<Packet>) -> FilterState<Packet> {
        (self.0)(f)
    }
}

impl Filter<Packet> for Packet {
    fn filter(&self, f: FilterState<Packet>) -> FilterState<Packet> {
        match f {
            FilterState::Pass(p) => {
                if &p != self {
                    FilterState::Drop
                } else {
                    FilterState::Pass(p)
                }
            }
            FilterState::Skip(p) => {
                if &p != self {
                    FilterState::Drop
                } else {
                    FilterState::Pass(p)
                }
            }
            FilterState::Drop => FilterState::Drop,
        }
    }
}
